pro ip, list, _extra = extra

  readcol, list, file, format='a', comment='#'
;  file = 'jupiter-31800_int.fits'

;  start = [dc, amp, sx, sy, xo, yo, angle]
;  name = ['Offset', 'Amplitude', 'SigmaX', 'SigmaY', 'X0', 'Y0', 'Angle']
;  pi = replicate({fixed:0, limited:[0,0], limits:[0,0], parname:' '},$
;                 n_elements(name))
;  pi.fixed=[0,0,0,0,0,0,0]
;  for i = 0, n_elements(name)-1 do begin
;      pi[i].parname = name[i]
;  endfor
;  pi.limited = [ $
;                 [0,0], $       ; Offset
;                 [1,0], $       ; Amplitude
;                 [1,0], $       ; sigma-X
;                 [1,0], $       ; sigma-Y
;                 [0,0], $       ; X-center
;                 [0,0], $       ; Y-center
;                 [0,0]  ]       ; Angle
;  pi.limits = [ $
;                [0,0], $        ; Offset
;                [0,0], $        ; Amplitude
;                [0,0], $        ; sigma-X
;                [0,0], $        ; sigma-Y
;                [0,0], $        ; X-center
;                [0,0], $        ; Y-center
;                [0,0]  ]        ; Angle
  ui = fltarr(n_elements(file))
  uierr = ui
  qi = ui
  qierr = ui
  elev = ui
  eleverr = elev
  tau = elev

;  for f = 0, 0 do begin
  for f = 0, n_elements(file)-1 do begin
      print, 'Filename = ' + file[f]
;      fits_info, file[f], n_ext = noext
      fits_read, file[f], imi, hdr, exten_no=0
      elev[f] = sxpar(hdr, 'TEL_ELEV')
      fits_read, file[f], tmp, hdr, exten_no=7
      extnam = sxpar(hdr, 'EXTNAME')
      if (extnam eq 'PIXEL MASK') then aa = 1 else aa = 0
      fits_read, file[f], ierr, hdr, exten_no=1 + aa
      fits_read, file[f], imq, hdr, exten_no=2 + aa
      fits_read, file[f], qerr, hdr, exten_no=3 + aa
      fits_read, file[f], imu, hdr, exten_no=4 + aa
      fits_read, file[f], uerr, hdr, exten_no=5 + aa
      fits_read, file[f], mask, hdr, exten_no=6 + aa
      fits_read, file[f], tmp, hdr, exten_no=7 + aa
      tau[f] = sxpar(hdr, 'TAU225GH')
      
      mx = max(imi[where(finite(imi) eq 1)])
      good = where(mask eq 0 and imi gt 0.9*mx)
;      good = where(mask eq 0 and imi gt 0.5*mx)

;;  Weighted average of complete Stokes parameters
;      rierr = total(1./ierr[good]^2)
;      rqerr = total(1./qerr[good]^2)
;      ruerr = total(1./uerr[good]^2)
;      ri = total(imi[good] / ierr[good]^2)
;      rq = total(imq[good] / qerr[good]^2)
;      ru = total(imu[good] / uerr[good]^2)
;      ri /= rierr  ; Average I
;      rq /= rqerr  ; Average Q
;      ru /= ruerr  ; Average U
;      rierr = 1. / sqrt(rierr)
;      rqerr = 1. / sqrt(rqerr)
;      ruerr = 1. / sqrt(ruerr)
;      qi[f] = rq / ri  ; Reduced q = Q/I
;      ui[f] = ru / ri  ; Reduced u = U/I
;      qierr[f] = sqrt(rqerr^2 + qi[f]^2 * rierr^2) / ri 
;      uierr[f] = sqrt(ruerr^2 + ui[f]^2 * rierr^2) / ri 
      
;  Weighted average of reduced Stokes parameters
      rq = imq[good] / imi[good]
      rqerr = sqrt(qerr[good]^2 + rq^2 * ierr[good]^2) / imi[good]
      ru = imu[good] / imi[good]
      ruerr = sqrt(uerr[good]^2 + ru^2 * ierr[good]^2) / imi[good]
      uierr[f] = total(1./ruerr^2)
      ui[f] = total(ru/ruerr^2)
      ui[f] /= uierr[f]
      uierr[f] = 1. / sqrt(uierr[f])
      qierr[f] = total(1./rqerr^2)
      qi[f] = total(rq/rqerr^2)
      qi[f] /= qierr[f]
      qierr[f] = 1. / sqrt(qierr[f])

;;  Unweighted average of reduced Stokes parameters
;      ui[f] = total(ru) / n_elements(ru)
;      qi[f] = total(rq)/ n_elements(rq)
;      uierr[f] = sqrt(total(ruerr^2)) / (n_elements(ru) - 1.)
;      qierr[f] = sqrt(total(rqerr^2)) / (n_elements(rq) - 1.)

      ; FIT
;      weights = mask* 0.
;      weights[where(mask eq 0)] = 1.
;      weights[where(mask gt 0)] = 0.
;      weights[where(imi lt 0.5*max(imi))] = 0.;
;  start = [dc, amp, sx, sy, xo, yo, angle]
;      start = [0., max(imi), 2.0, 2.0, 5.0, 5.0, 0.0]
;      yfit = mpfit2dpeak(imi, params, $
;                         estimates = start, $
;                         weights = weights, $
;                         chisq = chisq, dof=dof, perror = perror, /tilt)
;help, yfit, imi, params, ierr, start, chisq, dof, perror
;      print, 'chisq = ', chisq, dof, chisq/dof
;      print, 'params = ', params
;;      print, 'perrors = ', perror
;
;      plot, imi[*,6], psym=4
;      oplot, yfit[*,6]
;
;      plotimage, bytscl(imi), /preserve, title = file[f]
;      wait, 1
;      surface, imi, /lego
;      wait,1
  endfor
 for f = 0, n_elements(file)-1 do begin
      print, file[f], elev[f], tau[f]
  endfor
;print, qi
;stop
  
; Do linear regression using Ax = b
  b = [qi, ui]
  berr = [qierr, uierr]
  b = transpose(b)
  berr = transpose(berr)
  a1 = [replicate(1.0, n_elements(file)), $
        replicate(0.0, n_elements(file))]
  a2 = [replicate(0.0, n_elements(file)), $
        replicate(1.0, n_elements(file))]
  a3 = [cos(2.*elev*!dtor), -sin(2.*elev*!dtor)]
  a4 = [sin(2.*elev*!dtor), cos(2.*elev*!dtor)] 
  a1 /= berr
  a2 /= berr
  a3 /= berr
  a4 /= berr
  b /= berr
  a = [transpose(a1), transpose(a2), transpose(a3), transpose(a4)]
  ata = transpose(a) ## a
help, a, b
  atb = transpose(a) ## b
  cov = invert(ata)
  print, 'relative covariance matrix = '
  print, '        q_i         u_i           q_t           u_t'
  print, cov / max(cov)
  params = cov ## atb
  yfit = (a ## params)
help, yfit, berr,params
  chisq = total( (b - yfit)^2 ) 
  print, 'unreduced chisq = ', chisq
  chisq /= (n_elements(b) - n_elements(params))
  print, 'reduced chisq = ', chisq
  perror = sqrt(diag_matrix(cov))
  print, 'errors : ', perror
  perror *= sqrt(chisq)
  print, 'errors scaled so reduced chisq = 1 : ', perror
  smel = findgen(101)/100 * 90    ; Elevation vector for plotting
  qtot = params[2] * cos(2.*smel*!dtor) + params[3] * sin(2.*smel*!dtor) + $
    params[0] * 1.0 + params[1] * 0.0
  utot = -params[2] * sin(2.*smel*!dtor) + params[3] * cos(2.*smel*!dtor) + $
    params[0] * 0.0 + params[1] * 1.0

  erase
  multiplot, [0,1,2,0,0]
  y1 = min([qi, qtot])
  y2 = max([qi, qtot])
  plot, [0,90], [y1,y2], /xsty,/nodata, $
        ytit = 'Instrumental q'
  oploterror, elev, qi, eleverr, qierr, psym=4
;  oplot, elev, yfit[0:n_elements(elev)-1],/psym
  oplot, smel, qtot
;  for f = 0, n_elements(file)-1 do begin
;      label = strmid(file[f], 9, 4)
;      xyouts, elev[f], qi[f], label
;  endfor
;  help, elev, qi, files

  multiplot
  y1 = min([ui, utot])
  y2 = max([ui, utot])
  plot, [0,90], [y1,y2], /xsty,/nodata, $
    xtit = 'Telescope Elevation (degrees)', $
    ytit = 'Instrumental u'
  oploterror, elev, ui, eleverr, uierr, psym=4
;  for f = 0, n_elements(file)-1 do begin
;      label = strmid(file[f], 9, 4)
;      xyouts, elev[f], ui[f], label
;  endfor
  oplot, smel, utot
  ;help, a, ata, cov, params, a3, a4, a1, a2

  print, 'q_i(%) = ', params[0]*100, ' +/-', perror[0]*100
  print, 'u_i(%) = ', params[1]*100, ' +/-', perror[1]*100
  print, 'q_t(%) = ', params[2]*100, ' +/-', perror[2]*100
  print, 'u_t(%) = ', params[3]*100, ' +/-', perror[3]*100
  qis = string(format = '("q_i(%) = ", f5.2, " !M+!x ", f5.3)', $
               params[0]*100, perror[0]*100)
  uis = string(format = '("u_i(%) = ", f5.2, " !M+!x ", f5.3)', $
               params[1]*100, perror[1]*100)
  qts = string(format = '("q_t(%) = ", f5.2, " !M+!x ", f5.3)', $
               params[2]*100, perror[2]*100)
  uts = string(format = '("u_t(%) = ", f5.2, " !M+!x ", f5.3)', $
               params[3]*100, perror[3]*100)
  chi2s = string(format='("Reduced !4v!x!e2!n = ", f6.1)', chisq)
  xyouts, .15, .75-.03*0, qts, /norm
  xyouts, .15, .75-.03*1, uts, /norm
  xyouts, .15, .75-.03*2, qis, /norm
  xyouts, .15, .75-.03*3, uis, /norm
  xyouts, .15, .75-.03*4, chi2s, /norm

  stokes2polar, params[2], perror[2], params[3], perror[3], $
                pt, pterr, phit, phiterr
  stokes2polar, params[0], perror[0], params[1], perror[1], $
                pi, pierr, phii, phiierr
  print, 'Amp_t (%) = ', 100.*pt, ' +/- ', pterr*100
  print, 'phase_t (deg.) = ', phit, ' +/- ', phiterr
  print, 'Amp_i (%) = ', 100.*pi, ' +/- ', pierr*100
  print, 'phase_i (deg.) = ',  phii, ' +/- ', phiierr
  pts = string(format = '("P_t(%) = ", f4.2, " !M+!x ", f5.3)', $
               pt*100, pterr*100)
  phits = string(format = '("!4u!x_t(deg.) = ", f5.1, " !M+!x ", f4.1)', $
               phit, phiterr)
  pis = string(format = '("P_i(%) = ", f4.2, " !M+!x ", f5.3)', $
               pi*100, pierr*100)
  phiis = string(format = '("!4u!x_i(deg) = ", f5.1, " !M+!x ", f4.1)', $
               phii, phiierr)
  xyouts, .15, .4+.03*3, pts, /norm
  xyouts, .15, .4+.03*2, phits, /norm
  xyouts, .15, .4+.03*1, pis, /norm
  xyouts, .15, .4+.03*0, phiis, /norm

;  params = [2.90e-3, 2.43e-5, .0041, .0012]
;  qtot = params[0] * cos(2.*smel*!dtor) - params[1] * sin(2.*smel*!dtor) + $
;    params[2] * 1.0 + params[3] * 0.0
;  utot = -params[0] * sin(2.*smel*!dtor) - params[1] * cos(2.*smel*!dtor) + $
;    params[2] * 0.0 + params[3] * 1.0
;  wset,0
;  oplot, smel, qtot, linesty=2
;  wset,1
;  oplot, smel, utot, linesty=2
;print, 'old fit'
;print, 'q_t = ', params[0]
;print, 'u_t = ', params[1]
;print, 'q_i = ', params[2]
;print, 'u_i = ', params[3]
;print, 'Amp_t (%) = ', sqrt(params[0]^2 + params[1]^2) * 100.
;print, 'phase_t (deg.) = ', 0.5*atan(params[1], params[0]) * !radeg
;print, 'Amp_i (%) = ', sqrt(params[2]^2 + params[3]^2) * 100.
;print, 'phase_i (deg.) = ', 0.5*atan(params[3], params[2]) * !radeg



end
